// IE.h : main header file for the IE DLL
//

#if !defined(AFX_IE_H__58C0982D_D8D2_11D3_83A5_00E0811049D9__INCLUDED_)
#define AFX_IE_H__58C0982D_D8D2_11D3_83A5_00E0811049D9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#ifndef __IEMODEL_H
#include "IEModel.h"
#endif


#ifndef __MATRIX44_H
#include "Matrix44.h"
#endif

//#include "Vector4.h"

#ifndef __STRCLASS_H
#include "StrClass.h"
#endif

#ifndef __MISC_H
#include "SDK/Misc.h"
#endif

#include "Matrix34.h"

#define VERSION 2L

/////////////////////////////////////////////////////////////////////////////
// CHxtApp
// See IE.cpp for the implementation of this class
//

#define KFMVERSION  0x12345678+1
#define NUMCHANNELITEMS 10

enum ExpFileType { EFT_NEWCOPY, EFT_APPEND };
enum DirectXType { DX_SM, DX_RM };
enum ModelOrientation { DX_RIGHTHANDED, DX_LEFTHANDED };


class HModelCache;
class HObjectCacheContainer;
class FileStream;
class String;
class HProgressBar;
class HActionCache;
class HActionCacheContainer;
class HChor;
class HAnimObjectShortcut;
class HQuaternionRotateDriver;
class HChannelDriver;
class HBone;

#ifdef _OSX
typedef unsigned int UINT_PTR;
class CHxtApp : public CPluginApp
#else
class CHxtApp : public CWinApp
#endif
{
public:
	CHxtApp();
	virtual ~CHxtApp();
   IEPolyModelParms m_iemp;
   HProgressBar *m_hprogressbar;

 	void ReportExportError(const String &filename);

	BOOL OnExportModelCache(HModelCache *hmc);
   BOOL OnExportObjectCacheContainer(HObjectCacheContainer *hocc);
   BOOL OnExportActionCache(HActionCache *hac);

   LONG CountBones(IEPolyModel *model);
   BOOL ExportSkinnedMeshModel(IEPolyModel *model, const String &filename);
   BOOL ExportRetainedModeModel(IEPolyModel *model, const String &filename);

   void SaveAttributes(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SaveVertexList(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SaveAttributeIDList(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SaveNormalList(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SavePolys(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SaveBones(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void SaveBoneBranch(FileStream &fs, IEBone *bone, String &spaces, Matrix44 Parent, Matrix44 CombinedParent, LONG &totalitems, LONG &curritem);
   void SaveSkinWeights(FileStream &fs, IEBone *bone, LONG &totalitems, LONG &curritem);
   void SaveSkinInfo(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);

   BOOL IsMemberOfArray(LONG *array, int arraylength, int member);

   Matrix44 GetMatrixConversion(Matrix44 mOrig, Matrix44 mFinal);

   Matrix44 GetSkinWeightOffset(String &bonename);

   void WriteUVList(FileStream &fs, IEPolyModel *model);
   void InitNewPolys(int newpolynum);
   void InitMatList(IEPolyModel *model);
   void MaterialCleanup(FileStream &fs, IEPolyModel *model);
   char* RemovePathname(FileStream &fs, char* fullpathname);
   void GetVertexPolyNormalData(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void GetVertexPolyData(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void GetVertexPolyNormalDataNoVDIs(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void WriteVDIs(FileStream &fs, IEPolyModel *model, LONG &totalitems, LONG &curritem);
   void WriteVDIHeader(FileStream &fs);
   void WriteBoneHeader(FileStream &fs);
   BOOL ValidPolyMap(IEPolyModel *model, int polynum);

   int GetMaterialIndexWithTexture(IEPolyModel *model, int attrid, int textureid);

   // Retained Mode Specific Functions
   void WriteFVFDataHeader(FileStream &fs);
   void SaveRetainedModeBones(FileStream &fs, IEPolyModel *model);
   void SaveRetainedModeBoneBranch(FileStream &fs, IEPolyModel *model, IEBone *bone, String &spaces, Matrix44 Parent, Matrix44 CombinedParent);
   Vector RotateTransVertexByMatrix(Vector vertex, Matrix44 matrix, Matrix44 absolutematrix);
   Vector RotateVectorByMatrix(Vector vertex, Matrix44 matrix);

   CString GetValidDirectXName(CString inputName);
   void DuplicateNameCheck();

   BOOL ExportSMAnimationSet(float errortol, HActionCache *hac, HModelCache *hmc);
   BOOL ExportRMAnimationSet(float errortol, HActionCache *hac, HModelCache *hmc);
   Matrix34 CreateMatrix( const TSQ &tsq );
   Matrix34 GetMatrix(int actionindex, Time time);
   void GetSMFTMs(FileStream &fs2);
   void GetRMFTMs(FileStream &fs2);
   void WriteSMAnimationData(FILE * fs3);
   void WriteRMAnimationData(FILE * fs3);
   int GetChannelCount(const CString &bonename);

   Quaternion GetTSQRot(int actionindex, Time time);
   Vector GetTSQTrans(int actionindex, Time time);
   Vector GetTSQScale(int actionindex, Time time);

   bool buildChannelList(HActionCache *hac, HModelCache *hmc);
   void SaveBoneTransformDriver(int channelcount, HBone *bone, HAnimObjectShortcut *boneshortcut, float errortolerance, float scalefactor);
   BOOL SaveKeyFrames(int channelcount, HQuaternionRotateDriver *rotatedriver, HChannelDriver *translatedriver[], HChannelDriver *scaledriver[], float scalefactor);
   void SaveChannelDriver(int channelcount, int chanitemindex, HChannelDriver *channeldriver, float unit);



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHxtApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CHxtApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IE_H__58C0982D_D8D2_11D3_83A5_00E0811049D9__INCLUDED_)
